#ifndef _POINT_H
#define _POINT_H



/* header files we depend upon
 */
#include "../apptel/amcc.h"
#include "../apptel/fpga.h"
#include "../apptel/slavbrst.h"
#include "../apptel/suni622.h"
#include "../apptel/aim_cpld.h"



/* errors
 */
#define ERROR_POINT_NOT_INITIALIZED      200        // not used yet
#define ERROR_POINT_MISSING_ARGS         201        // used by our callers
#define ERROR_POINT_NO_SUCH_CARD         202
#define ERROR_POINT_FPGA_UNMAPPED        203
#define ERROR_POINT_AIM_CPLD_UNMAPPED    204
#define ERROR_POINT_CANNOT_MAP_PHYS      205
#define ERROR_POINT_AMCC_UNMAPPED        206
#define ERROR_POINT_SLAVE_BURST_UNMAPPED 207
#define ERROR_POINT_CANNOT_ALLOC         208        // used by our callers
#define ERROR_POINT_AIM_SUNI622_UNMAPPED 209



class AtmCard
{

public:
    int init_result;

    Bit8 card_index;
    Bit16 card_handle;

    Bit32 amcc_phys_address;
    Bit32 amcc_mem_handle;
    Amcc_registers *amcc;

    Bit32 fpga_phys_address;
    Bit32 fpga_mem_handle;
    Fpga_registers *both_fpgas;

    Bit32 slave_burst_phys_address;

    Bit32 suni_phys_address;
    Bit32 suni_mem_handle;
    Suni_registers *suni;

    Bit32 aim_and_cpld_phys_address;
    Bit32 aim_and_cpld_mem_handle;
    AimAndCpld_registers *aim_and_cpld;

    // constructor
    //
    AtmCard( Bit8 cardindex );

    // destructor
    //
    ~AtmCard();

};



#endif  /* not included yet */
