#ifndef _AAL5_H
#define _AAL5_H



#include "../integrat/constant.h"       /* CELLS_PER_PACKET */
#include "../integrat/trace.h"



/* which bits of timestamp hold cell count */

#define CELL_COUNT_MASK        3

/* how many cells the card is allowed to give us, minus 1
 */
#if (CELLS_PER_PACKET > 4) || ((CELLS_PER_PACKET==4) && CARD_COPIES_LAST_CELL) || CARD_COPIES_ALL_CELLS
#   define CELL_COUNT_MAX      3
#else
#if CELLS_PER_PACKET < 1
#   define CELL_COUNT_MAX      0
#else
#if CARD_COPIES_LAST_CELL
#   define CELL_COUNT_MAX      CELLS_PER_PACKET
#else
#   define CELL_COUNT_MAX      (CELLS_PER_PACKET - 1)
#endif
#endif
#endif




// helps detect and recover from circular (defective) linked lists
//
#define MAX_LIST_LENGTH         10000



struct cellhashrec
{
    tracerec *first;
    tracerec_2 *second;
    tracerec_last *last;
    cellhashrec *next;       /* for collision resolution and access time */
    Bit8 interface;
};



int cells_init( void );
void cells_query( tcp_Socket *sock );
int cells_clear( void );
int cells_cleanup( void );
int cells_reassemble( struct tracerec *record, Bit8 interface );
PentiumClock cells_get_last_reassemble_timing( void );
void cells_dump_all_packets( void *sock );
int cells_check_all_packets( void *sock );

/* these 2 are actually in INTEGRAT/TRACE.C
 */
extern void dump_packet( void *sock, cellhashrec *chp );
extern int check_packet( void *sock, cellhashrec *chp );



#endif  /* not included yet */
