#include <stdio.h>                      // printf()
#include "../types/types.h"             // Bit32 Bit16 Bit8
#include "../integrat/dump.h"           // make_printable()
#include "../wattcp/tcp.h"              // sock_printf()



// always does complete lines
//
// indent is in addition to existing 2 spaces
//
void hex_dump_long( void *sock, void *start, Bit32 length, int want_address, const char *indent )
{
    Bit32 *address;
    Bit32 count;
    Bit16 line;

    if( want_address )
        sock_printf( sock, "%sdumping 32-bit values starting at 0x%8.8lX, length 0x%8.8lX\n", indent, start, length );

    for( address=(Bit32 *)start; length>15; address+=16,length-=16 )
    {
        if( want_address )
            sock_printf( sock, "%s%8.8lX  ", indent, address );
        else
            sock_printf( sock, "%s ", indent );

        for( line=0; line<4; line++ )
        {
            sock_printf( sock, " %8.8lX", address[line] );
        }

        sock_printf( sock, "\n" );
    }
}



// always does complete lines
//
// indent is in addition to existing 2 spaces
//
void hex_dump_char( void *sock, void *start, Bit32 length, unsigned per_line, int want_address, int want_alpha, const char *indent )
{
    Bit8 *address;
    Bit32 count;
    Bit16 line;

    if( want_address )
        sock_printf( sock, "%sdumping 8-bit values starting at 0x%8.8lX, length 0x%8.8lX, %d per line\n", indent, start, length, per_line );

    for( address=(Bit8 *)start; length>15; address+=per_line,length-=per_line )
    {
        if( want_address )
            sock_printf( sock, "%s%8.8lX  ", indent, address );
        else
            sock_printf( sock, "%s ", indent );

        // hex goes on left
        //
        for( line=0; line<per_line; line++ )
            sock_printf( sock, " %2.2X", address[line] );

        // alpha goes on right
        //
        if( want_alpha )
        {
            sock_printf( sock, "    " );

            for( line=0; line<per_line; line++ )
                sock_printf( sock, "%c", make_printable( address[line] ) );
        }

        sock_printf( sock, "\n" );
    }
}



