#include <limits.h>
#include <string.h>


char *ultoa( unsigned long value, char *string, int radix )
{
    unsigned long mask;
    int found_nonzero_bit;
    char *pos;

    if( radix != 2 )
    {
        strcpy( string, "only radix 2 impl" );
        return string;
    }

#if 0
    mask = 1 << 31;             // word size dependency!
#else
    mask = ULONG_MAX - LONG_MAX;
#endif
    found_nonzero_bit = 0;
    pos = string;
    while( mask )
    {
        if( value & mask )
        {
            *pos++ = '1';
            found_nonzero_bit = 1;
        }
        else
            if( found_nonzero_bit )
                *pos++ = '0';

        mask = mask / 2;
    }

    *pos++ = '\0';
    return string;
}
