#include <stdio.h>                          // fprintf() printf()
#include <stdlib.h>                         // strtoul()
#include "../intel/timestmp.h"              // class PentiumClock



int main( int argc, char *argv[] )
{
    PentiumClock now, alarm;
    char *program = argv[ 0 ];
    char *delay_string = argv[ 1 ];
    Bit32 delay;
    int want_beep = argc == 3;

    if( argc < 2 )
    {
        fprintf( stderr, "waits the desired amount of seconds, and optionally beeps\n" );
        fprintf( stderr, "usage: %s seconds want_beeps\n", program );
        fprintf( stderr, "\twhere want_beep is a placeholder\n" );
        return 1;
    }

    delay = strtoul( delay_string, NULL, 0 );

    printf( "waiting %lu seconds\n%s",
        delay,
        want_beep ? "\007" : ""
    );

    alarm.put_seconds( delay );
    now.set();
    alarm += now;

    while( now < alarm )
        now.set();

    printf( "done\n%s", want_beep ? "\007" : "" );

    return 0;
}

