#include <stdio.h>
#include <dos.h>
#include <stdlib.h>                     // free()
#include "..\wattcp\tcp.h"
#include "..\wattcp\elib.h"
#include "..\types\types.h"
#include "..\dpmi32\intr.h"
#include "..\dpmi32\far.h"


static Bit48 oldinterrupt;
static vfp thunk;
static void (*userroutine)(void) = NULL;
static int inside = 0;

#define TIMER_INTERRUPT 0x08

// turn off compiler warning about unused parameters cs and eip
// since I know they won't be used and I must have
// them because calling code cannot be changed
//
#pragma warn -par

static int newinterrupt( void *parms, Bit32 ebp, Bit32 edi, Bit32 esi,
    Bit32 ds, Bit32 es, Bit32 edx, Bit32 ecx, Bit32 ebx, Bit32 eax,
    Bit32 eip, Bit32 cs, Bit32 eflags )
{
    /* chain to old interrupt handler before our
     * processing, so it sees low timing jitter
     */
    far_call( oldinterrupt, ebp, edi, esi, ds, es, edx, ecx, ebx, eax, eflags );

    disable();
    if (!sem_up( &inside )) {
        enable();
        if (userroutine) (*userroutine)();
        tcp_tick( NULL );
        disable();
        inside = 0;
    }
    enable();

    /* please don't chain to old handler
     */
    return FALSE;
}

// turn compiler warning about unused parameters
// back to whatever it was before I messed with it
//
#pragma warn .par



void backgroundon(void)
{
    Bit48 pointer;

    oldinterrupt = getvect( TIMER_INTERRUPT );

    thunk = make_thunk( newinterrupt, &oldinterrupt, NULL );

    pointer.offset = (Bit32) thunk;
    pointer.selector = _CS;
    setvect( TIMER_INTERRUPT, pointer );
}



void backgroundoff(void)
{
    setvect( TIMER_INTERRUPT, oldinterrupt );
    free( thunk );
}



void backgroundfn( void (*fn)() )
{
    userroutine = fn;
}
